#jinja2:lstrip_blocks: True
global
  log /dev/log    local0
  log /dev/log    local1 notice
  chroot /var/lib/haproxy
  stats socket /run/haproxy/admin.sock mode 660 level admin expose-fd listeners
  stats timeout 10s
  user haproxy
  group haproxy
  daemon
  maxconn {{ lb.max_connections }}

  # Default ciphers to use on SSL-enabled listening sockets.
  # For more information, see ciphers(1SSL). This list is from:
  #  https://hynek.me/articles/hardening-your-web-servers-ssl-ciphers/
  # An alternative list with additional directives can be obtained from
  #  https://mozilla.github.io/server-side-tls/ssl-config-generator/?server=haproxy
  ssl-default-bind-ciphers ECDH+AESGCM:DH+AESGCM:ECDH+AES256:DH+AES256:ECDH+AES128:DH+AES:RSA+AESGCM:RSA+AES:!aNULL:!MD5:!DSS
  ssl-default-bind-options no-sslv3

defaults
  log     global
  mode    tcp
  option  tcplog
  option  dontlognull
  timeout connect 5000
  timeout client  10000
  timeout server  10000
  errorfile 400 /etc/haproxy/errors/400.http
  errorfile 403 /etc/haproxy/errors/403.http
  errorfile 408 /etc/haproxy/errors/408.http
  errorfile 500 /etc/haproxy/errors/500.http
  errorfile 502 /etc/haproxy/errors/502.http
  errorfile 503 /etc/haproxy/errors/503.http
  errorfile 504 /etc/haproxy/errors/504.http

frontend http-80
  bind {{ lb.external_ip }}:80
  mode http
  redirect scheme https code 301

{% for balancer in lb.balancers %}
frontend {{ balancer.name }}-{{ balancer.frontend_port }}
  mode {{ balancer.mode }}
  bind {{ lb.external_ip }}:{{ balancer.frontend_port }}
  option tcplog
  default_backend {{ balancer.name }}-{{ balancer.frontend_port }}

backend {{ balancer.name }}-{{ balancer.frontend_port }}
  balance {{ balancer.algorithm }}
  mode {{ balancer.mode }}
  {% for manager in groups.managers %}
  server {{ balancer.name }}-{{ balancer.frontend_port }}-{{ loop.index }} {{ hostvars[manager]['private_ipv4'] }}:{{ balancer.frontend_port }} check send-proxy-v2
  {% endfor %}

{% endfor %}
